module BookmarksMenuF(bookmarksMenuF,toolbarF) where
import Fudgets
--import ContribFudgets(superMenuF,MenuItem(..))
import SuperMenuF(superMenuF,MenuItem(..))
import ReadBookmarks(Bookmarks(..))
import Data.Maybe(mapMaybe)

bookmarksMenuF = bMenuF "Bookmarks"

bMenuF title menu =
   snd>^=<superMenuF Nothing menuFont title (toMenu menu) fst

toolbarF = untaggedListLF placer . mapMaybe toTool
  where
    placer = leftS `spacerP` horizontalP' 0
    toTool (Bookmark title url) = Just (const url >^=< buttonF title>=^^<nullSP)
    toTool (Menu title menu) = Just (bMenuF title menu)
    toTool _ = Nothing

toMenu = concatMap tm
  where
    tm bm =
      case bm of
        Bookmark title url -> [Item (title,url)]
        Menu title menu -> [Submenu (title++" >>",toMenu menu)]
        _ -> []
