module Arrows(lArrowD,rArrowD,homeD) where
import Fudgets

lArrowD = arrowD pts r
  where
    r = rR 12 3 4 4

rArrowD = arrowD pts' r
  where
    pts' = [pP 16 10 - p | p<-pts]
    r = rR 0 3 4 4

arrowD pts r =
    spacedD (hvMarginS m m) $
    stackD [
      fgD "white" $ fd [FillPolygon Convex CoordModeOrigin pts,
			 FillArc r 0 (64*360)],
      fgD ["blue4","#0000cc","black"] $
          fd [DrawLines CoordModeOrigin pts,DrawArc r 0 (64*360)]
    ]
  where
    m = Point 1 4

fd = g . FixD (Point 17 11)

pts = [pP 0 5,pP 5 0,pP 5 3,pP 10 3,pP 10 7,pP 5 7,pP 5 10,pP 0 5]

homeD = spacedD (hvMarginS (pP 0 1) (pP 2 7)) $
        stackD [
          fgD "white" $ fd [FillPolygon Nonconvex CoordModeOrigin pts],
          fgD ["blue4","#00c","black"] $
              fd [DrawLines CoordModeOrigin (pts++pts2)]]
  where
    pts = map (uncurry pP)
          [(2,8),(0,8),(3,5),(3,0),(5,0),(5,3),
           (8,0),(16,8),(14,8),(14,14),(9,14),(9,9),(6,9),
           (6,14),(2,14),(2,8)]
    pts2 = map (uncurry pP) [(3,8),(8,3),(13,8)]
