-- | Data types for PNM images, <http://netpbm.sourceforge.net/doc/#formats>
module PNM(module PNM,RGB(..)) where
import RGB

data PNM = PNM Size PNMdata --deriving (Show)

type Size = (Int,Int)

data PNMdata = PPM Int [PPM_RGB] -- ^ maximal color component value, rgb values
             | PGM Int [Gray] -- ^ maximal gray value, gray values
	     | PBM [Bit]
	     --deriving (Show)

type PPM_RGB = RGB Int
type Gray = Int
type Bit = Bool -- ^ where False==White, True=Black
